import javax.sound.sampled.*;

import javax.swing.*;

import java.awt.*;

import java.awt.event.*;

import java.io.*;

/**

 * The sound class plays the sound file passed to it

 * and is used in the Sokoban program

 * 

 * 3/2/02 - Kevin Blomseth adapted to Sokoban

 */



public class Sound

{



    private static Clip clip;

    /**

     * Link to the sound file for pushing a crate

     */

    private static String pushSound = ".\\Sound\\push.wav";

    /**

     * Link to the sound file for moving the robot

     */

    private static String moveSound = ".\\Sound\\move.wav";

    /**

     * Link to the sound file for burning a crate

     */

    private static String burnSound = ".\\Sound\\burn.wav";

    /**

     * Link to the sound file for finishing a level

     */

    private static String doneSound = ".\\Sound\\done.wav";



    /**

     * Plays the sound file passed.

     */

    private static void playSound(String filename)

    {

        AudioInputStream audio = null;

        try

        {

            audio = AudioSystem.getAudioInputStream(new File(filename));

        }

        catch (UnsupportedAudioFileException e)

        {}

        catch (IOException e)

        {

            e.printStackTrace();

        }

        if (audio != null)

        {

            AudioFormat format = audio.getFormat();

            DataLine.Info info = new DataLine.Info(Clip.class, format);

            try

            {

                clip = (Clip)AudioSystem.getLine(info);

                clip.open(audio);

            }

            catch (LineUnavailableException e)

            {

                e.printStackTrace();

            }

            catch (IOException e)

            {

                e.printStackTrace();

            }

            clip.start();

        }

    }



    /**

     * Plays the moving sound

     */

    public static void playMoveSound()

    {

        playSound(moveSound);

    }



    /**

     * Plays the sound used when pushing a crate

     */

    public static void playPushSound()

    {

        playSound(pushSound);

    }



    /**

     * Plays the sound used when a crate is pushed into an incinerator

     */

    public static void playBurnSound()

    {

        playSound(burnSound);

    }



    /**

     * Plays the sound associated with finishing a level

     */

    public static void playDoneSound()

    {

        playSound(doneSound);

    }



}





