/**
 * <p>The Square class extends the Enumerate class and represents the different
 * types of squares located on a map.</p>
 * <p>These types include:<br>
 * 1. empty space<br>
 * 2. robot<br>
 * 3. crate<br>
 * 4. incinerator<br>
 * 5. wall<br>
 * 6. starting position<br>
 * </p>
 *
 * @author Kevin Blomseth
 * @date 11/27/2001
 * @version 1.0
 *
 */
//Version History
//  11/27/01 Kevin Blomseth added algorithm pseudocode

public class Square extends Enumerate
{

    public static final Square EMPTY = new Square("EMPTY");
    public static final Square ROBOT = new Square("ROBOT");
    public static final Square CRATE = new Square("CRATE");
    public static final Square INCINERATOR = new Square("INCINERATOR");
    public static final Square WALL = new Square("WALL");
    public static final Square STARTING_POSITION = new Square("STARTING_POSITION");

    /**
     * <p>Constructor - calls the constructor of the Enumerate class that
     * Square inherits.</p>
     *
     * @param name the name of the square: empty, robot, crate, incinerator,
     * wall, or starting position
     */
    public Square (String name)
    {
        // CALL Enumerate constructor with super(name)
        super(name);
    }
}
