import junit.framework.*;

/**
 * This is a JUnit test for game.postMove().
 * 
 * Test Method
 *      game.postMove()
 * 
 * testPost
 *      Tests the post move module.
 */
public class GameTest2 extends TestCase
{
    SGui gui;
    SGui gui2;
    Game game;
    Game game2;
    MultiplayerDialog diag;
    Robot first;
    Robot second;

    public GameTest2 (String name)
    {
        super (name);
    }

    /**
     * This method creates a game and a gui for the game
     * to reference to.
     */
    public void setUp()
    {
        gui = new SGui(true);
        gui.setVisible(false);
        game = new Game(gui);
        diag = new MultiplayerDialog(gui, game);
        diag.setVisible(false);
    }

    /**
     * starts a server and check to asserts if 
     * server is listening 
     */
    public void testHosting()
    {
        game.startServer(3000, diag);
        assertTrue(game.isHosting());
    }

    /**
     * starts a server and a second instance of 
     * the game that connects to the server.
     * asserts to see the connection exists 
     * and test for disconnect
     */
    public void testConnection()
    {   
      try
      {
        game.startServer(4000, diag);
        gui2 = new SGui(true);
        gui2.setVisible(false);
        game2 = new Game(gui2);
        game2.startClient("localhost", 4000, diag);
        Thread.sleep(4000);
        assertTrue(game2.isClientConnected());
        game.stopMultiplayer();
        assertTrue(!game.isHosting());
      }
      catch (InterruptedException e) 
      {
      }
    }




}

