import junit.framework.*;
import java.io.*;

public class HighScoresListTest extends TestCase 
{
	protected HighScoresList list = new HighScoresList(true);

	public HighScoresListTest(String name)
    {
    	super(name);
    }
	
	protected void setUp()
    {
    }
	
	public void testAddHighScore() 
	{
		list.loadHighScores();
		list.clearHighScores();
		list.addHighScore(new HighScore("Josh", 3000));
		HighScore[] scores = list.toArray();
		assertTrue(scores.length == 1);
		assertEquals(scores[0].getName(), "Josh");
		assertTrue(scores[0].getScore() == 3000);
	}

	public void testAddLowerScore() 
	{
		list.loadHighScores();
		HighScore score = new HighScore("Bob", 300);
		list.addHighScore(score);
		HighScore[] scores = list.toArray();
		assertTrue(scores.length == 2);
		assertEquals(scores[0].getName(), "Josh");
		assertTrue(scores[0].getScore() == 3000);
		assertEquals(scores[1].getName(), "Bob");
		assertTrue(scores[1].getScore() == 300);
	}
	
	public void testAddHigherScore() 
	{
		list.loadHighScores();
		list.addHighScore(new HighScore("Bubba", 4000));
		HighScore[] scores = list.toArray();
		assertTrue(scores.length == 3);
		assertEquals(scores[0].getName(), "Bubba");
		assertTrue(scores[0].getScore() == 4000);
		assertEquals(scores[1].getName(), "Josh");
		assertTrue(scores[1].getScore() == 3000);
		assertEquals(scores[2].getName(), "Bob");
		assertTrue(scores[2].getScore() == 300);
	}
	
	public void testClearHighScores()
	{
		list.loadHighScores();
		list.clearHighScores();
		HighScore[] scores = list.toArray();
		assertTrue(scores.length == 0);
	}
	
	public void testNegativeScore()
	{
		list.addHighScore(new HighScore("Josh", -13));
		HighScore[] scores = list.toArray();
		assertTrue(scores.length == 0);
	}
	
	public void testNameWithSpaces()
	{
		list.loadHighScores();
		list.clearHighScores();
		list.addHighScore(new HighScore("Josh Thompson", 15));
		HighScore[] scores = list.toArray();
		assertTrue(scores.length == 1);
		assertEquals(scores[0].getName(), "JoshThompson");
		assertTrue(scores[0].getScore() == 15);
	}
}
	


