import junit.framework.*;

public class LevelEditorUITest extends TestCase 
{
	LevelEditorUI r1;

	public LevelEditorUITest (String name)
    {
    	super (name);
    }
	
	protected void setUp()
    {
    	r1 = new LevelEditorUI();
    }
	
	public void testSaveAndLoadAndNewLevelNoExtension()
	{
		r1.loadLevel("./levels/Level 1");
		for(int i=0; i<Constants.maxCol; i++)
		{
			assertTrue((r1.getEditor().getValueAt(0,i)).equals(Square.WALL));
		}
		
		for (int i=0; i<Constants.maxCol; i++)
		{
			r1.getEditor().setValueAt(Square.INCINERATOR,0,i);
		}
		
		for(int i=0; i<Constants.maxCol; i++)
		{
			assertTrue((r1.getEditor().getValueAt(0,i)).equals(Square.INCINERATOR));
		}
		
		r1.saveLevel("./levels/testLevel1");
		
		r1.newLevel();
		
		for(int i=0; i<Constants.maxRow; i++)
		{
			for(int j=0; j<Constants.maxCol; j++)
			{
				assertTrue((r1.getEditor().getValueAt(i,j)).equals(Square.EMPTY));
			}
		}
		
		r1.loadLevel("./levels/testLevel1");
		
		for(int i=0; i<Constants.maxCol; i++)
		{
			assertTrue((r1.getEditor().getValueAt(0,i)).equals(Square.INCINERATOR));
		}
	}
	
	public void testSaveAndLoadAndNewLevelWithExtension()
	{
		r1.loadLevel("./levels/Level 1.lvl");
		for(int i=0; i<Constants.maxCol; i++)
		{
			assertTrue((r1.getEditor().getValueAt(0,i)).equals(Square.WALL));
		}
		
		for (int i=0; i<Constants.maxCol; i++)
		{
			r1.getEditor().setValueAt(Square.CRATE,0,i);
		}
		
		for(int i=0; i<Constants.maxCol; i++)
		{
			assertTrue((r1.getEditor().getValueAt(0,i)).equals(Square.CRATE));
		}
		
		r1.saveLevel("./levels/testLevel2.lvl");
		
		r1.newLevel();
		
		for(int i=0; i<Constants.maxRow; i++)
		{
			for(int j=0; j<Constants.maxCol; j++)
			{
				assertTrue((r1.getEditor().getValueAt(i,j)).equals(Square.EMPTY));
			}
		}
		
		r1.loadLevel("./levels/testLevel2.lvl");
		
		for(int i=0; i<Constants.maxCol; i++)
		{
			assertTrue((r1.getEditor().getValueAt(0,i)).equals(Square.CRATE));
		}
	}
	
	public void testBadData()
	{
		r1.loadLevel("./levels/baddata.lvl");
		
		r1.saveLevel("./levels/testLevel3.lvl");
		
		r1.newLevel();
		
		for(int i=0; i<Constants.maxRow; i++)
		{
			for(int j=0; j<Constants.maxCol; j++)
			{
				assertTrue((r1.getEditor().getValueAt(i,j)).equals(Square.EMPTY));
			}
		}
		
		r1.loadLevel("./levels/Level 1");
		
		for(int i=0; i<Constants.maxCol; i++)
		{
			assertTrue((r1.getEditor().getValueAt(0,i)).equals(Square.WALL));
		}
		
		r1.loadLevel("./levels/testLevel3.lvl");
		
		for(int i=0; i<10; i++)
		{
			for(int j=0; j<Constants.maxCol; j++)
			{
				assertTrue((r1.getEditor().getValueAt(i,j)).equals(Square.EMPTY));	
			}
		}
	}		
}
	


